/**************************************************************************************************************
 *
 * PIC18F6620-Modul
 *
 * Datei : defines.h
 *
 * Autoren : Finger
 *
 * Controller : Microchip 18F6620, 40 Mhz
 * Einstellungen:  OSC=HS, WDT=OFF, PWT=ON, CP=OFF, BOD=ON, LVP=OFF
 *
 *************************************************************************************************************/

// Standard-defines
#define ON  1
#define EIN 1
#define TRUE ON
#define OFF 0
#define AUS 0
#define FALSE OFF

#define Bit0                1
#define Bit1                2
#define Bit2                4
#define Bit3                8
#define Bit4                16
#define Bit5                32
#define Bit6                64
#define Bit7                128

//---------------
// Steuerzeichen
//---------------
#define CR  0x0d
#define LF  0x0a

//-------------------------
// Allegmeine Pufferdaten
//-------------------------
#define Buflen                 50

//--------------
// Ausgangspins
//--------------
#define BatMonEin							 RA0          // High = Batteriemonitor einschalten

#define	LichtAn								 RB4					// Displaybeleuchtung einschalten

#define HeizungEin						 RC0				  // High = Heizung einschalten
#define SaftAn								 RC1					// High = Eigene Versorgung einschalten

// Schalteingnge
#define Anruf									 RB0          // Eingang vons Hndi
#define Zuendung  						 RC2					// High = Zndung eingeschaltet
#define Taster								 RB1          // Drucktaster
#define Links									 RB2
#define Rechts								 RB3

//---------
// Display
//---------
#define	E											 RD0
#define RW										 RD1
#define RS									   RD2

// Fehlerkonstanten

#define KeinFehler					 0
#define Fehlerwert 					-1000
#define Timeout							-1
#define Bedienwunsch		  	-2
#define Ueberlauf						-3

// RTC
#define ControlReg              0x00
#define I2CTimeout  						100

//----------------------------------
// Funktionen des Zustandsautomaten
//----------------------------------

// Phasenbergnge zwischen den Zustnden
#define ZuendungEin								1
#define ZuendungAus               2
#define Tastendruck               3
#define ZeitAbgelaufen            4
#define ManuellerStart            5
#define ManuellesEnde             6
#define Telestart                 7
#define TeleEnde                  8
#define TastenDruck								9

// Mgliche Zustnde des Systems
#define ZustandKuehlen						101
#define ZustandParameter          102
#define ZustandHeizen             103
#define ZustandBetrieb            104
#define ZustandSchlafen           105

//------------------------------
// Sekunden bis Anzeigenwechsel
// und andere Zeiten
//------------------------------
#define Anzeigedauer								5					// n Sekunden, dann den nchsten Wert zeigen
#define DefaultHeizZeit							30*60			// 30 Minuten  60 Sekunden
#define DefaultLatenzZeit						120				// Sekunden, in denen das Heizen per Telestart nicht abgebrochen werden kann
#define DefaultKuehlZeit						120				// Sekunden fr den Nachlauf des Heizmllers
#define DefaultEinstellZeit					 60				// Eine Minute kein Tastendruck -> Abschalten
#define DefaultZuendungausZeit			 30				// Eine Minute, dann ganz aus
#define BatMonTimeoutDefault			30







