/**************************************************************************************************************
 *
 * Entwicklungsumgebung : MPLAB, PIC-C 18
 *
 * Beschreiben und lesen des internen EEProm
 *
 *************************************************************************************************************/

#include	<pic18.h>
#include 	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<stdlib.h>
#include	<stdio.h>

#include "eep.h"

/******************************************************************************
*  Internes EEProm beschreiben fr PIC 18F6x20
*  bergbeparameter : 10 Bit Adresse 8 bit Daten
*  fr andere Typen kann der Adressbereich grsser oder kleiner 8 Bit sein dann
*  mu die Funktion entsprechend angepasst werden.
*******************************************************************************/
void EEPromSchreiben( unsigned int ADR, unsigned char DATA)
{
  EEADRH = (ADR>>8) & 0x3;
  EEADR = ADR & 0xFF;     // Adresse
	EEDATA = DATA;   // Daten
	EEPGD = 0;       // EEProm beschreiben
	CFGS = 0;
	WREN = 1;        // Schreiben freigeben

//	GIE = 0;         // globaler interrupt aus
	EECON2 = 0x55;   // ist vorgeschrieben mu so gemacht werden damit wird die
	EECON2 = 0xAA;   // Speicherung gestartet
	WR = 1;          // Schreiben
	while (WR==1);   // warten bis fertig, WR wird zurck gesetzt wenn der
	                 // Schreibzyklus abgeschlossen ist
//	GIE = 1;         // globaler interrupt an
	WREN = 0;        // Schreiben sperren
}
/******************************************************************************
*  Internes EEProm lesen fr PIC 18Fx720
*  bergabeparameter : 10 Bit Adresse
*  Rckgabeparameter : 8 bit Daten
*  fr andere Typen kann der Adressbereich grsser oder kleiner 8 Bit sein dann
*  mu die Funktion entsprechend angepasst werden
*******************************************************************************/

unsigned char EEPromLesen(unsigned int ADR)
{
  EEADRH = (ADR>>8) & 0x3;
  EEADR = ADR & 0xFF;     // Adresse
	EEPGD = 0;
	CFGS = 0;
	RD = 1;
	return EEDATA;
}
